# Contributing to the Casper SDK 

Thanks for your interest in the SintiFi's Casper SDK. Our goal is to provide a Java SDK with all features to interact with the Casper Networks in a Java friendly way.

## Getting Started

The sdk's [open issues are here](https://github.com/syntifi/casper-sdk/issues). An easy way to get started helping the project is to *file an issue*. You can do that on the Casper-skd issues page by clicking on the green button at the right. Issues can include bugs to fix, features to add, or documentation that looks outdated. 

If you have any ideas you would like to discuss, please kick of a new discussion at [ideas](https://github.com/syntifi/casper-sdk/discussions/categories/ideas).

For some tips on contributing to open source, this [post is helpful](https://smartbear.com/blog/test-and-monitor/14-ways-to-contribute-to-open-source-without-being/).

## Contributions

SyntiFi's Casper-SDK welcomes contributions from everyone.

Contributions to the SDK should be made in the form of GitHub pull requests. Each pull request will
be reviewed by a core contributor (someone with permission to land patches) and either landed in the
main tree or given feedback for changes that would be required.

## Pull Request Checklist

- Branch from the master branch and, if needed, rebase to the current master
  branch before submitting your pull request. If it doesn't merge cleanly with
  master you may be asked to rebase your changes.

- Commits should be as small as possible, while ensuring that each commit is
  correct independently (i.e., each commit should compile and pass tests). 

- Don't put submodule updates in your pull request unless they are to landed
  commits.

- If your patch is not getting reviewed or you need a specific person to review
  it, you can @-reply a reviewer asking for a review in the pull request or a
  comment.

- Add tests relevant to the fixed bug or new feature.  

## Conduct & License

We follow the [Rust Code of Conduct](http://www.rust-lang.org/conduct.html).

All code in this repository is released under the Apache 2 License, and by contributing to this repository, you agree to release that contribution under that same license. 


## Reference

A lot of these contribution guidelines were borrowed from the [deeplearning4j project](https://github.com/eclipse/deeplearning4j). Thank you!
